<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { accessTokenKey, api, refreshTokenKey } from "~/common/constaint";
import _ from "lodash";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { IItemListTrackingExport } from "~/interfaces/order";
var XLSX = require("xlsx");
var moment = require("moment");

@Component({})
export default class TrackingComponent extends Vue {
  @Prop()
  tab!: number;

  config = {
    page: 1,
    limit: 25,
    search: "",
    filter: {
      type: "add",
    },
  };
  totalPage: number = 0;
  page = 1;

  listTracking = [];
  loadingTable = false;

  file = null;

  mounted() {
    this.onGetListTracking();
  }

  async onGetListTracking() {
    try {
      this.loadingTable = true;
      const response = await this.$api.order.adminGetListTracking(this.config);
      if (response?.data?.data) {
        const { total } = response.data;
        this.totalPage = Math.ceil(total / this.config.limit);
        this.listTracking = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  loadingUpload = false;

  onHandleTracking() {
    return new Promise((resolve, reject) => {
      const reader = new FileReader();
      var that = this;
      reader.onload = async (e: any) => {
        try {
          /* Parse data */
          const bstr = e.target.result;
          const wb = XLSX.read(bstr, { type: "binary" });
          /* Get first worksheet */
          const wsname = wb.SheetNames[0];
          const ws = wb.Sheets[wsname];
          /* Convert array of arrays */
          const data = XLSX.utils.sheet_to_json(ws, { header: 1 });
          that.dataExcel = data;
          resolve(true);
        } catch (error) {
          this.$pushNotification.error("Error when processing files");
        }
      };
      //@ts-ignore
      reader.readAsBinaryString(this.file);
    });
  }
  dataExcel = null;
  @Watch("dataExcel")
  async onDataChanged(data: any) {
    try {
      this.loadingUpload = true;
      await this.$utils.sleep(500);
      if (!data) return;
      let payload: any = [];
      const listRow = data.filter((item: any) => item.length);
      if (listRow.length > 3000) {
        return this.$pushNotification.error(
          "Please reduce excel rows less than 3000"
        );
      }
      const listData = listRow.splice(1);
      const findIndexItemCode = listRow[0].findIndex(
        (item: string) => item === "Order Number"
      );
      const findIndexTrackingNumber = listRow[0].findIndex(
        (item: string) => item === "Tracking Number"
      );
      const findIndexCarrier = listRow[0].findIndex(
        (item: string) => item === "Carrier Code"
      );
      for (let item of listData) {
        const data = {
          orderCode: item[findIndexItemCode],
          trackingNumber: item[findIndexTrackingNumber],
          carrierCode: item[findIndexCarrier],
        };
        payload.push(data);
      }
      await this.onAddTracking(payload);
      await this.onGetListTracking();
    } catch (error) {
      this.$pushNotification.error("Error when processing files");
    } finally {
      this.loadingUpload = false;
    }
  }
  async onChange(event: any) {
    const files = event;
    if (!files) return;
    this.file = files || null;
    this.onHandleTracking();
  }
  dragover(event: any) {
    event.preventDefault();
  }
  dragleave(event: any) {}
  drop(event: any) {
    event.preventDefault();
    const files = [];
    for (let file of Object.keys(event.dataTransfer.files)) {
      const item = event.dataTransfer.files[file];
      files.push(item);
    }
    this.onChange(files[0]);
  }

  onSelectFile() {
    this.resetImageUploader();
    //@ts-ignore
    this.$refs.fileExcel.$refs.input.click();
  }

  resetImageUploader() {
    //@ts-ignore
    this.$refs.fileExcel.$refs.input.value = "";
  }

  async onAddTracking(body: any) {
    try {
      if (body.length) {
        await this.$api.order.adminAddTracking(body);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  calcValueProgress(tracking: any) {
    const progressCurrent = tracking.total - tracking.failed;
    return Math.round((progressCurrent / tracking.total) * 100);
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }
  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListTracking();
  }

  json_fields = {
    "Order Number": "orderNumber",
    "Tracking Number": "trackingNumber",
    "Carrier Code": "carrierCode",
  };
  json_data = [
    {
      orderNumber: "",
      trackingNumber: "",
      carrierCode: "",
    },
  ];
  json_meta = [
    [
      {
        key: "charset",
        value: "utf-8",
      },
    ],
  ];

  json_fieldsError = {
    "Order Number": "orderNumber",
    Message: "message",
    Type: "type",
    TransactionId: "transaction_id",
  };
  json_dataError: IItemListTrackingExport[] = [
    // {
    //   orderNumber: "",
    //   message: "",
    //   type: "",
    //   transaction_id: "",
    // },
  ];

  onExportFile() {
    //@ts-ignore
    this.$refs.export.$el.click();
  }

  onExportFileDuplicate(tracking: any, i: number) {
    const listFailed = tracking.listFailed;
    let listErrPaypal = [];
    let listErrStripe = [];
    if (tracking?.listErrPaypal?.length) {
      listErrPaypal = JSON.parse(tracking.listErrPaypal);
    }
    if (tracking?.listErrStripe?.length) {
      listErrStripe = JSON.parse(tracking.listErrStripe);
    }
    const listAll = [...listErrPaypal, ...listErrStripe];
    for (let item of listFailed) {
      this.json_dataError.push({
        orderNumber: item.orderCode,
        message: "Not found orderCode",
        type: "",
        transaction_id: "",
      });
    }
    for (let item of listAll) {
      this.json_dataError.push({
        orderNumber: item.orderCode,
        message: item.message || "",
        type: item.transaction_id ? "Paypal" : "Stripe",
        transaction_id: item.transaction_id || item.id || "",
      });
    }
    //@ts-ignore
    this.$refs.exportError[i].$el.click();
  }

  calcTotalError(tracking: any) {
    let total = 0;
    let listErrPaypal = [];
    let listErrStripe = [];
    if (tracking.listErrPaypal) {
      listErrPaypal = JSON.parse(tracking.listErrPaypal);
    }
    if (tracking.listErrStripe) {
      listErrStripe = JSON.parse(tracking.listErrStripe);
    }
    if (listErrPaypal.length) {
      total += listErrPaypal.length;
    }
    if (listErrStripe.length) {
      total += listErrStripe.length;
    }

    return total;
  }

  @Watch("tab")
  changeTab(value: number) {
    if (value === 0) {
      this.onGetListTracking();
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListTracking();
  }
}
</script>

<style>
.border-uploadfile-tracking {
  border: 1px dashed #c3c3c3;
  border-radius: 4px;
}

.border-uploadfile-tracking:hover {
  border-color: #008060;
  background: rgba(0, 128, 96, 0.05);
}
</style>
